#!/usr/bin/env python

#           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#                   Version 2, December 2004

# Copyright (C) 2018 Daniel Jakots


import binascii
import base64
import sys

try:
    import qrcode
except ModuleNotFoundError:
    print("pkg_add py3-qrcode")
    sys.exit(1)

seed_hex = input("Key in hex format ")

binary_string = binascii.unhexlify(seed_hex)
seed_b32 = base64.b32encode(binary_string).decode('utf-8')

print("The secret in a base32 encoded format")
print(seed_b32)

print("The same, but with a space every three letters for readability")
print(' '.join([seed_b32[i:i+3] for i in range(0, len(seed_b32), 3)]))

print("Let's create a QR code to import it into an app")
issuer = input("'Issuer' (can be the server name) ")
username = input("Username ")

uri = f"otpauth://totp/{username}?secret={seed_b32}&issuer={issuer}"
img = qrcode.make(uri)
image_file = open(f"qrcode-otp-{issuer}.jpg", "wb")
img.save(image_file)
